Attribute VB_Name = "Module1"
Option Explicit

Sub prn2pbm()
Dim PRNbyte As String
Dim GraphicMode As Boolean
Dim GraphicLowByte As Byte
Dim GraphicHiByte As Byte
Dim GraphicLineWidth As Integer
Dim GraphicLine()
Dim GraphicRowCount As Integer
Dim PRNbyteCounter As Integer
Dim BitPosition As Integer
Dim PRNgraphicByte As Byte
Dim Escaped As Boolean
Dim TextCounter As Integer
Dim Header As String
Dim MaxGraphicLineWidth As Integer

Header = PreScan()
MaxGraphicLineWidth = Val(Mid$(Header, 4, InStr(4, Header, " ") - 4))
Print #2, Header;
On Error Resume Next
Do
    If EOF(1) Then Exit Do
    PRNbyte$ = Input$(1, #1)
    If EOF(1) Then Exit Do
    If (Not Escaped) And (Not GraphicMode) And (Asc(PRNbyte$) = 27) Then
        Escaped = True
    ElseIf Escaped Then
        Escaped = False
        If (PRNbyte$ = "K" Or PRNbyte$ = "L" Or PRNbyte$ = "Y" Or PRNbyte$ = "Z") Then
            GraphicMode = True
            PRNbyte$ = Input$(1, #1)
            GraphicLowByte = Asc(PRNbyte$)
            PRNbyte$ = Input$(1, #1)
            GraphicHiByte = Asc(PRNbyte$)
            GraphicLineWidth = GraphicLowByte + (256 * GraphicHiByte)
            ReDim GraphicLine(1 To 8, 1 To MaxGraphicLineWidth)
        Else
            GraphicMode = False
        End If
    ElseIf GraphicMode Then
        GraphicRowCount = GraphicRowCount + 8
        Form1.ProgressBar1.Value = Loc(1) * 100 / LOF(1)
        GraphicMode = False
        'Read a line from the PRN file and store it column-by-column
        For PRNbyteCounter = 1 To GraphicLineWidth
            PRNgraphicByte = Asc(PRNbyte$)
            For BitPosition = 8 To 1 Step -1
               GraphicLine(BitPosition, PRNbyteCounter) = PRNgraphicByte Mod 2
               PRNgraphicByte = Int(PRNgraphicByte / 2)
            Next BitPosition
            PRNbyte$ = Input$(1, 1)
        Next PRNbyteCounter

        'Now write the 8 rows to the temp PBM file row-by-row
        For BitPosition = 1 To 8
            For PRNbyteCounter = 1 To MaxGraphicLineWidth
                If GraphicLine(BitPosition, PRNbyteCounter) = 1 Then
                    Print #2, " 1";
                Else
                    Print #2, " 0";
                End If
            Next PRNbyteCounter
        Next BitPosition
    Else
        Print #3, PRNbyte$;
        TextCounter = TextCounter + 1
    End If
Loop
Form1.ProgressBar1.Value = 100
Form1.Label4.Caption = "Source File Size " & LOF(1) & " bytes" & Chr$(13) & Chr$(10) & _
    "Graphic Type PBM P1 2-color ASCII" & Chr$(13) & Chr$(10) & _
    "Graphic File Size " & LOF(2) & " bytes" & Chr$(13) & Chr$(10) & _
    "Graphic Width " & GraphicLineWidth & " pixels" & Chr$(13) & Chr$(10) & _
    "Graphic Height " & GraphicRowCount & " pixels" & Chr$(13) & Chr$(10) & _
    "Text File Size " & TextCounter & " bytes"

Close
Form1.ProgressBar1.Value = 0
End Sub


